#draw_slope_normals.rb
#Auther :TAK2HATA
#site: http://sketchup-onigiri.jimdo.com/
###日本語
#General disclaimer
#I MAKES NO GUARANTEE OF VALIDITY about this script.
#Please use this script at your own risk.
##免責事項
##このスクリプトによって如何なる損害が発生しても製作者は責任を負いません。各人の責任においてご使用ください。
#勾配と方向を描画する
#面の傾きをそろえる
#頂点のＺ座標を指定する
#エッジの平均高さを求める
require "sketchup.rb"

module Draw_slope_normal_common_func
	def getMenu(menu)
		#takdsf_cmenu=menu.add_submenu(langconv( "Draw Slope Normals"))
		menu.add_item( langconv( "Set Z value.") ) { Sketchup.active_model.select_tool DSN_Click_Set_vertex_zvalue.new }
		menu.add_item( langconv( "Arrange The Slope of Two faces." ) ) { Sketchup.active_model.select_tool DSN_Click2Faces_to_fit_plane.new }
	end
	def curve_add()
		#選択したエッジ群からカーブを作る
		model = Sketchup.active_model
		ents = model.active_entities
		sels = model.selection
		vts = []
		eds = []
		#選択している頂点をすべて抜き出す
		sels.each{|sel|
			if sel.kind_of? Sketchup::Edge
				eds.push sel
				sel.vertices.each{|vt|
					vts.push vt if not vts.include?( vt )
				}
			end
		}
		#始点になる頂点を決める
		svt = vts[0]
		vts.each{|vt|
			xeds = vt.edges.find_all{|ed| eds.include?( ed ) == true }
			if xeds.size == 1
				svt = vt
				break
			end
		}
		#svt = vts.find{|vt| vt.edges == 1 }
		cvts = []#新しい曲線用の頂点配列
		cvts.push svt.position
		vt = svt
		p vts.to_a
		ned = svt.edges[0]
		while vts != [] 
			nvt = ned.other_vertex(vt)
			p "next vt#{nvt}"
			break if not vts.include?( nvt )
			vt = vts.slice!( vts.index( nvt ) , 1 )[0]
			
			cvts.push vt.position

			vt.edges.each{|ed|
				if ed != ned
					ned = ed
					break
				end
			}
		end
		#p cvts
		ents.erase_entities eds
		#eds.each{|ed| ed.hidden = true}
		#ents.add_curve vts.map{|vt| vt.position }
		ents.add_curve cvts
	end
	def select_langfile
		lang_dir = File.join( File.dirname( File.expand_path(__FILE__) ), "draw_slope_normals" , "languages" )
		#File.dirname( Sketchup.find_support_file "lang.txt", "Plugins/draw_slope_normals/languages/" )
		lang_path=UI.openpanel(langconv("Select Language File"),lang_dir,"*.txt")
		return false if lang_path == "" or lang_path == false
		return false if not lang_path
		#lang_path.gsub!(/\\/,File::SEPARATOR)
		lang_path = File.expand_path( lang_path )
		if not FileTest.exist?( lang_path )
			UI.messagebox( "File is not exists!(or The file-path includes special characters)::#{lang_path}" )
		end
		Sketchup.write_default( "DrawSlopeNormals", "lang_path", lang_path )
		load_langtxt( )
		UI.messagebox langconv("The language convert will be effecvie after Sketchup restarted")
	end
	def load_langtxt( )
		lang_path =  File.join( File.dirname( File.expand_path(__FILE__) ), "draw_slope_normals" , "languages" , "lang.txt")
		#Sketchup.find_support_file "lang.txt", "Plugins/draw_slope_normals/languages/"
		lang_path = Sketchup.read_default( "DrawSlopeNormals", "lang_path", lang_path )
		#lang_path.gsub!(/\\/,File::SEPARATOR)
		return nil if not lang_path
		lang_path = File.expand_path( lang_path )
		return nil if not FileTest.exist?( lang_path )
		
		@langhash = Hash.new
		
		lang_file=File.new(lang_path,"r")##read mode
		lang_file.each{|line|
			if line != "" and line[0] != "#" and line["\|"]
				splt = ( line.chomp ).split("\|")
				if splt[0] != "" and splt[1] != ""
					@langhash[splt[0]] = splt[1]
				end
			end
		}
		lang_file.close
	end
	def langconv( tstr )
		ret = ""
		load_langtxt if @langhash == nil
		return tstr if @langhash == nil
		if @langhash.size > 0
			ret = @langhash[tstr] if @langhash[tstr] != nil
			ret = tstr if ret == ""
		else
			ret = tstr
		end
		return ret
	end
end
module Draw_slope_on_view
	def activate
		self.reset
		model = Sketchup.active_model
		view = model.active_view
		view.invalidate
		$draw_slope_normal = false
	end
	def deactivate(view)
		$draw_slope_normal = false
	end
	def onCancel(flag, view)
		Sketchup.active_model.selection.clear
		$draw_slope_normal = false
		Sketchup.send_action("selectSelectionTool:")
	end
	def search_vt_active_group( pt )
		model = Sketchup.active_model
		ments = model.active_entities
		vtlist = []
		idlist = []
		ments.find_all{|e| e.kind_of? Sketchup::Edge }.each{|ed|
			ed.vertices.each{|vt|
				if not idlist.index( vt.entityID )
					idlist.push vt.entityID
					vtlist.push vt
				end
			}
		}
	end
	def is_in_view( view , pt )
		pt2d = view.screen_coords( pt )
		#minv2d = view.corner(0)
		maxv2d = view.corner(3)
		#p minv2d
		#p maxv2d
		#p pt2d
		return true if pt2d[0] < maxv2d[0] and pt2d[0] > 0 and pt2d[1] < maxv2d[1] and pt2d[1] > 0
		return false
	end
	def draw_on_view_slope_arrow(view)
		model = Sketchup.active_model
		ments = model.active_entities
		arrows = []
		arrows2 = []
		arrow_texts = []
		vtlist = []
		idlist = []
		ip1 = view.inputpoint( view.center[0] , view.center[1] )
		vcpt = ip1.position
		arrow_length = view.pixels_to_model( 100 , vcpt )
		arrow_length = 2000.mm if arrow_length > 2000.mm
		arrow_length = 200.mm if arrow_length < 200.mm
		ments.find_all{|e| e.kind_of? Sketchup::Face }.each{|fc|
			nvec = fc.normal
			#hpt = fc.vertices[0].position
			#lpt = fc.vertices[0].position
			cpt = Geom::Point3d.new(0,0,0)
			fc.vertices.each{|vt|
				cpt.x = cpt.x + vt.position.x / fc.vertices.size
				cpt.y = cpt.y + vt.position.y / fc.vertices.size
				cpt.z = cpt.z + vt.position.z / fc.vertices.size

				#if not idlist.index( vt.entityID )
				#	idlist.push vt.entityID
				#	vtlist.push vt
				#end
			}
			#cpt = [ 0 ,1, 2 ]
			#cpt.each{|i| i = ( hpt[i] + lpt[i] /2.0 ) }
			nvec2 = nvec.clone
			nvec2.z = 0.0
			if nvec2.length == 0.0
			elsif is_in_view( view , cpt )
				arvec = nvec.cross(Geom::Vector3d.new( 0,0,1 )).cross( nvec )
				arvec.length = arrow_length if arvec.length != 0.0
				#adef = creat_arrow_for_slope()
					arrowpt = []
					arrowpt[0] = cpt + arvec
					arrowpt[1] = cpt + arvec.reverse
					arrowpt[2] = arrowpt[1].clone
					arrowpt[2].z = arrowpt[0].z
					arrowpt[3] = cpt.clone
					arrowpt[3].z = arrowpt[0].z
					arrows.push arrowpt[0]
					arrows.push arrowpt[1]
					arrows.push arrowpt[1]
					arrows.push arrowpt[2]
					arrows.push arrowpt[0]
					arrows.push arrowpt[2]

					slopetext = "1/#{ sprintf( '%.1f' ,nvec.z / nvec2.length ) }"
					arrow_texts.push [ arrowpt[3] , slopetext ]
			end
		}
		ments.find_all{|e| e.kind_of? Sketchup::Edge }.each{|ed|
			ed.vertices.each{|vt|
				if not idlist.index( vt.entityID )
					idlist.push vt.entityID
					vtlist.push vt
				end
			}
		}
		vtlist.each{|vt|
			if is_in_view( view , vt.position )
				vecs = Geom::Vector3d.new( 0.0,0.0,0.0 )
				#座標を引き出す先へのベクトルを計算で求め、表示を見やすくする。
				vt.edges.each{|ed|
					if ed.hidden? == false
						vecs = vecs + vt.position.vector_to( ed.other_vertex(vt).position )
					end
				}
				#vecs.length = arrow_length
				vecs.reverse!
				vecs.z = vecs.length * 2.0
				vecs.length = arrow_length if vecs.length != 0.0
				leadervec = vecs#Geom::Vector3d.new( arrow_length , 0.mm , arrow_length )
				if is_in_view( view , ( vt.position + leadervec ) )
					arrows2.push( vt.position )
					arrows2.push( vt.position + leadervec )
					vttext =  "Z=#{vt.position.z.to_l}"#{ sprintf( '%.1f' , vt.position.z.to_l )}"
					arrow_texts.push [ vt.position + leadervec , vttext ]
				end
			end
		}
		view.line_width=2
		view.drawing_color = "RED"
		view.draw_lines arrows if arrows.length > 1
		view.drawing_color = "GREEN"
		view.draw_lines arrows2 if arrows2.length > 1
		arrow_texts.each{|pt,txt|
			view.draw_text( view.screen_coords( pt ) , txt)
		}
	end
end#module

class DSN_Click2Faces_to_fit_plane
	include Draw_slope_on_view
	include Draw_slope_normal_common_func
	def draw(view)
		draw_on_view_slope_arrow(view)
		Sketchup::set_status_text @message
	end
	def initialize
		$draw_slope_normal = true
		@ip = Sketchup::InputPoint.new
		@zval = 0.0
		@sels = Sketchup.active_model.selection
		@sel = []
		Sketchup.active_model.selection.clear
		@state = 0
	end

	def reset
		@ip.clear
		@sels.clear
		@sel = []
		@message = "Select Click Origin face"
		#Sketchup::set_status_text @message
	end

	def activate
		self.reset
		model = Sketchup.active_model
		view = model.active_view
		view.invalidate
	end

	def onCancel(flag, view)
		$draw_slope_normal = false
		Sketchup.active_model.selection.clear
		Sketchup.send_action("selectSelectionTool:")
	end

	def onMouseMove(flags, x, y, view)

	end

	def onLButtonDown(flags, x, y, view)
		@ip.pick(view,x,y)
		vt = @ip.vertex
		ed = @ip.edge
		fc = @ip.face
		if fc != nil
			if @state == 0
				@plane1 = fc.plane
				@state = 1
				Sketchup.active_model.selection.add fc
				@message = "Select Click face for Change"
				#Sketchup::set_status_text @message
				view.invalidate
			elsif @state == 1
				vts = fc.vertices
				vecs = []
				vts.each{|vt|
					pt1 = vt.position
					line1 = [ pt1 , Geom::Vector3d.new(0,0,1) ]
					pt2 = Geom.intersect_line_plane( line1 , @plane1 )
					#pt2 = pt1.project_to_plane( @plane1 )
					vec = pt1.vector_to( pt2 )
					vecs.push vec
				}
				Sketchup.active_model.start_operation langconv( "Arrange the slopes of Two Faces." )
				fc.parent.entities.transform_by_vectors( vts , vecs )
				Sketchup.active_model.commit_operation
				#余分な稜線を消す
				#edlist = fc.edges
				#model = Sketchup.active_model

				#dsfv = Draw_slope_face_vector.new
				#dsfv.delete_flatten_lines_do( edlist )
				
				Sketchup.active_model.selection.clear
				view.invalidate

				@state = 0
			else
				Sketchup.active_model.selection.clear
				@state = 0
			end

		end
	end

end

##点のZ座標を指定
class DSN_Click_Set_vertex_zvalue
	include Draw_slope_on_view
	include Draw_slope_normal_common_func
	def draw(view)
		draw_on_view_slope_arrow(view)
		Sketchup::set_status_text @message
	end
	def initialize
		$draw_slope_normal = true
		@ip = Sketchup::InputPoint.new
		@zval = 0.0
		@sels = Sketchup.active_model.selection
		@sel = []
		@avts = []
		Sketchup.active_model.active_entities.find_all{|e| e.kind_of? Sketchup::Edge }.each{|ed| @avts.push ed.vertices.map{|vt| vt } }
		if @avts != []
			@avts.flatten!
			@avts.uniq!
		end
	end

	def reset
		@ip.clear
		@sels.clear
		@sel = []
		@message = "Select Click Vertex"
		#Sketchup::set_status_text @message
	end


	def onMouseMove(flags, x, y, view)

	end
	def check_path( t , path = [] )
		if not t.kind_of? Sketchup::Model
			path.push t.parent
			check_path( t.parent , path )
		end
		return path
	end
	def onLButtonDown(flags, x, y, view)
		model = Sketchup.active_model

		@ip.pick(view,x,y)
		pt = @ip.position
		#ph = view.pick_helper
		#ph.do_pick x,y
		#allpicked = ph.all_picked
		#apath = Sketchup.active_model.active_path
		vt = @ip.vertex
		ed = @ip.edge
		#ed = nil
		fc = @ip.face

		#return if not @avts.include?( vt ) and not ed
		if vt
			if not @avts.include?( vt )
				avts_pick = @avts.find{|avt| avt.position == vt.position }
				vt = avts_pick
			end
		end

		result = false
		@zval = 0.0
		if vt
			@zval = vt.position.z
		elsif ed
			@zval = ed.start.position.z
		elsif fc
			@zval = calc_z_average_of_edges( fc.edges )
		end
		title = langconv( "Set Z value." )
		prompt = langconv( "Z VALUE" )
		result = UI.inputbox( [prompt], [@zval.to_s], title )

		return if result == false
		
		zval = 0.0
		begin
			zval = result[0].to_l
		rescue
			zval = 0.0
		end
		#if vt
		vts = []
		if vt
			vts = [vt]
		elsif ed
			vts = ed.vertices
		elsif fc
			vts = fc.vertices
		end
		Sketchup.active_model.start_operation langconv( "Set Z value." )

		vts.each{|vt|
			@zval = vt.position.z
			if @zval != zval
				curves = []
				vt.edges.each{|ed|
					crv = ed.curve
					if crv and not curves.index( crv )
						curves.push crv
					end
				}
				if curves != []
					curves.each{|crv|
						l = crv.length
						almax = 0.0
						blmax = 0.0
						apts = []
						bpts = []

						chk = false
						dist = 0.0
						ppt = crv.vertices[0].position
						ppt.z = 0.0
						crv.vertices.each{|vt2|
							cpt = vt2.position
							cpt.z = 0.0
							dist = ppt.distance( cpt )
							if vt2 == vt
								chk = true
								almax += dist
								blmax += dist
							elsif chk == false
								apts.push [ vt2.position , dist ]
								almax += dist
							else
								bpts.push [ vt2.position , dist ]
								blmax += dist
							end
							ppt = vt2.position
							ppt.z = 0.0
						}
						#zval = vt.position.z
						dist = 0.0
						mvpts = []

						apts.each{|pt,ln|
							if pt
								dist += ln
								if almax == 0.0
									nzval = ( apts[0][0].z - zval )
								else
									nzval = ( apts[0][0].z - zval ) * ( almax - dist ) / almax
								end
								pt.z = zval + nzval
								mvpts.push pt
							end
						}
						pt = vt.position
						pt.z = zval
						mvpts.push pt
						dist = 0.0
						bpts.each{|pt,ln|
							if pt	
								dist += ln
								if blmax == 0.0
									nzval = ( bpts[ bpts.length - 1 ][0].z - zval )
								else
									nzval = ( bpts[ bpts.length - 1 ][0].z - zval ) * dist / blmax
								end
								pt.z = zval + nzval
								mvpts.push pt
							end
						}
						crv.move_vertices( mvpts )
					}
					#Sketchup.active_model.commit_operation
				else
					#Sketchup.active_model.start_operation "頂点座標の変更"
					tvec = Geom::Vector3d.new( 0, 0, zval - @zval )
					tr =  Geom::Transformation.translation( tvec )
					vt.parent.entities.transform_entities( tr , vt )
					#Sketchup.active_model.commit_operation
				end
			end
		}
		view.invalidate
		Sketchup.active_model.commit_operation
		
		
		#elsif ed
		#	trvecs = []
		#	ed.vertices.each{|vt|
		#		pt1 = vt.position
		#		pt2 = pt1.clone
		#		pt2.z = zval
		#		trvecs.push pt1.vector_to( pt2 )
		#	}
		#	ed.parent.entities.transform_by_vectors( ed.vertices , trvecs )
		#end
	end
	def roundoff(l,d=0)
		x = 10**d
		if l < 0
		  (l * x - 0.5).ceil.quo(x)
		else
		  (l * x + 0.5).floor.quo(x)
		end
		return l
	end
	def calc_z_average_of_edges( edges = [] )
		model = Sketchup.active_model
		sels = model.selection
		areas = 0.0
		lens = 0.0
		chk = true
		if edges == []
			chk = false
			edges = sels.find_all{|sel| sel.kind_of? Sketchup::Edge }
		end
		edges.each{|sel|
			apt = sel.start.position
			bpt = sel.end.position
			linc = [ apt.x , apt.y , 0 ].distance([ bpt.x , bpt.y , 0 ])
			l = linc
			az = apt.z
			bz = bpt.z
			area = ( l * ( az + bz ) / 2 )
			lens = lens + l
			areas = areas + area
			#p "長さ:#{l.to_mm}--面積:#{area.to_mm.to_mm}"
		}
		avg = areas / lens
		if chk == false
			UI.messagebox langconv("The Average Height Of selected Edges is:") + avg.to_l.to_s
		else
			return avg
		end
	end
end

class Draw_slope_face_vector
	include Draw_slope_normal_common_func
	def calc_z_average_of_edges( edges = [] )
		model = Sketchup.active_model
		sels = model.selection
		areas = 0.0
		lens = 0.0
		chk = true
		if edges == []
			chk = false
			edges = sels.find_all{|sel| sel.kind_of? Sketchup::Edge }
		end
		edges.each{|sel|
			apt = sel.start.position
			bpt = sel.end.position
			linc = [ apt.x , apt.y , 0 ].distance([ bpt.x , bpt.y , 0 ])
			l = linc
			az = apt.z
			bz = bpt.z
			area = ( l * ( az + bz ) / 2 )
			lens = lens + l
			areas = areas + area
			#p "長さ:#{l.to_mm}--面積:#{area.to_mm.to_mm}"
		}
		avg = areas / lens
		if chk == false
			UI.messagebox langconv("The Average Height Of selected Edges is:") + avg.to_l.to_s
		else
			return avg
		end
	end
	def draw_normal_onface
		model = Sketchup.active_model
		ments = model.active_entities
		title = langconv( "Length Of Arrows" )
		prompt = langconv( "Length of Arrows" )
		arrlength = Sketchup.active_model.get_attribute("DRAW_SLOPE_NORMALS","ARROW_LENGTH", 1270.mm )
		result = UI.inputbox( [prompt], [arrlength], title )
		return if result == false
		@arrlen = result[0].to_l
		Sketchup.active_model.set_attribute("DRAW_SLOPE_NORMALS","ARROW_LENGTH", @arrlen )
		
		agp = ments.add_group
		ents = agp.entities
		sel = model.selection
		slopeinfos = []
		sel.find_all{|e| e.kind_of? Sketchup::Face }.each{|fc|
			nvec = fc.normal
			cpt = Geom::Point3d.new(0,0,0)
			fc.vertices.each{|vt|
				cpt.x = cpt.x + vt.position.x / fc.vertices.size
				cpt.y = cpt.y + vt.position.y / fc.vertices.size
				cpt.z = cpt.z + vt.position.z / fc.vertices.size
			}
			nvec2 = nvec.clone
			nvec2.z = 0.0
			if nvec2.length == 0.0
			else
				nvec2.normalize!
				slopetext = "1/#{ sprintf( '%.1f' ,1 / Math.tan( nvec.angle_between( Geom::Vector3d.new( 0,0,1 ) ))) }"
				rot = Math.atan2( nvec2.y , nvec2.x )
				
				tr = Geom::Transformation.rotation( Geom::Point3d.new(0,0,0), Geom::Vector3d.new( 0,0,1 ), rot )
				tr = Geom::Transformation.translation( Geom::Point3d.new(0,0,0).vector_to( cpt ) ) * tr
				
				###Math.atan2( nvec.y , nvec.x )が通常の使い方だがあえて逆
				##if Math.atan2( nvec.x , nvec.y ) >= 0
				##end
				slopeinfos.push [ slopetext , cpt , tr ]
				#ents.add_instance adef , tr
				#ents.add_text slopetext ,cpt
			end
		}
		vtlist = []
		idlist = []
		sel.find_all{|e| e.kind_of? Sketchup::Face }.each{|fc1|
			fc1.vertices.each{|vt1|
				if not idlist.index( vt1.entityID )
					idlist.push vt1.entityID
					vtlist.push vt1
				end
			}
		}
	Sketchup.active_model.start_operation langconv("Draw the vectors of slopes.")
		adef = creat_arrow_for_slope()
		slopeinfos.each{| slopetext , cpt , tr |
			ents.add_instance adef , tr
			ents.add_text slopetext ,cpt
		}
		#arrow_length = 1000.mm
		vtlist.each{|vt|
			vecs = Geom::Vector3d.new( 0.0,0.0,0.0 )
			vt.edges.each{|ed|
				if ed.hidden? == false
					vecs = vecs + vt.position.vector_to( ed.other_vertex(vt).position )
				end
			}
			#vecs.length = arrow_length
			vecs.reverse!
			vecs.z = vecs.length * 2.0
			vecs.length = @arrlen if vecs.length != 0.0
			leadervec = vecs#Geom::Vector3d.new( arrow_length , 0.mm , arrow_length )
			vttext = "#{vt.position.z}"
			ents.add_text vttext ,vt.position , leadervec
		}
	Sketchup.active_model.commit_operation


		return
		##
		sel.find_all{|e| e.kind_of? Sketchup::Edge }.each{|ed|
			pt1 = ed.start.position
			pt2 = ed.end.position
			if pt1.z == pt2.z
			else
				if pt2.z > pt1.z
					pt1 , pt2 = pt2 , pt1
				end
				nvec = pt1.vector_to(pt2)
				nvec2 = nvec.clone
				nvec2.z = 0.0
				cpt = Geom::Point3d.new( ( pt1.x + pt2.x ) / 2, ( pt1.y + pt2.y ) / 2, ( pt1.z + pt2.z ) / 2)
				if nvec2.length == 0.0
				else
					nvec2.normalize!
					adef = creat_arrow_for_slope()

					slopetext = "1/#{ sprintf( '%.1f' ,1 / Math.tan( nvec.angle_between( nvec2 ))) }"
					rot = Math.atan2( nvec2.y , nvec2.x )
					
					tr = Geom::Transformation.rotation( Geom::Point3d.new(0,0,0), Geom::Vector3d.new( 0,0,1 ), rot )
					tr = Geom::Transformation.translation( Geom::Point3d.new(0,0,0).vector_to( cpt ) ) * tr
					ents.add_instance adef , tr
					ents.add_text slopetext ,cpt
				end
			end
		}
	end

	def creat_arrow_for_slope()
		defs = Sketchup.active_model.definitions
		adef = defs["arrow_to_slope"]
		if adef == nil
			arrlen = @arrlen
			pt1 = Geom::Point3d.new( - arrlen / 2 ,0,1000.mm)
			pt2 = Geom::Point3d.new( arrlen / 2 ,0,1000.mm)
			pt3 = Geom::Point3d.new( arrlen / 4 , arrlen / 5 ,1000.mm)
			pt4 = Geom::Point3d.new( arrlen / 4 , -arrlen / 5 ,1000.mm)
			adef = defs.add("arrow_to_slope")
			adef.entities.add_line pt1 ,pt2
			adef.entities.add_line pt3 ,pt2
			adef.entities.add_line pt4 ,pt2
		else
		end
		return adef
	end
	def delete_flatten_lines()
		model = Sketchup.active_model
		sels = model.selection
		delete_flatten_lines_do( sels.find_all{|e| e.kind_of? Sketchup::Edge } )
	end
	def delete_flatten_lines_do( eds = [] )
		killist = []
		eds.each{|ed|
			nvec = nil
			ed.faces.each{|fc|
				if nvec == nil
					nvec = fc.normal
				elsif fc.normal.samedirection?( nvec )
					killist.push ed
					break
				end
			}
		}
		if killist != []
			killist[0].parent.entities.erase_entities killist
		end
	end
	def add_menus_of_this()
		takdsfvmenu = UI.menu.add_submenu(langconv( "Draw Slope Normals"))
		takdsfvmenu.add_item( langconv( "Set Z value.") ) { Sketchup.active_model.select_tool DSN_Click_Set_vertex_zvalue.new }
		#takdsfvmenu.add_item( langconv( "Erase Flattened lines." ) ) { delete_flatten_lines }
		takdsfvmenu.add_item( langconv( "Arrange The Slope of Two faces." ) ) { Sketchup.active_model.select_tool DSN_Click2Faces_to_fit_plane.new }
		takdsfvmenu.add_item( langconv( "The Average Height of Selected Edges." ) ) { calc_z_average_of_edges }
		takdsfvmenu.add_item( langconv( "Draw Slope Vectors on Selected Faces.") ) { draw_normal_onface }
		#takdsfvmenu.add_item( langconv( "Curve from Selected edges.") ) { curve_add }
		takdsfvmenu.add_item( langconv( "Change Language" ) ) { select_langfile }
		takdsfvmenu.add_item( langconv( "About This" ) ) {
			msg = langconv("Title:") + "Draw Slope normals" + "\n"
			msg << langconv("Auther:") + "TAK2HATA" + "\n"
			msg << langconv("Translator Auther:") + "\n"
			msg << langconv("version:") + "1.4" + "\n"
			msg << langconv("Update:") + "Mar 26,2013" + "\n"
			msg << ":BUGFIX" + "\n"
			msg << langconv("General disclaimer") + "\n"
			msg << langconv("AUTHER MAKES NO GUARANTEE OF VALIDITY about this script.") + "\n"
			msg << langconv("Please use this script at your own risk.") + "\n"
			UI.messagebox msg
		}
		#UI.add_context_menu_handler do |menu|
		#	if $draw_slope_normal == true
		#		menu.add_separator 
		#		takdsf_cmenu=menu.add_submenu(langconv( "Draw Slope Normals"))
		#		takdsf_cmenu.add_item( langconv( "Set Z value.") ) { Sketchup.active_model.select_tool DSN_Click_Set_vertex_zvalue.new }
		#		takdsf_cmenu.add_item( langconv( "Arrange The Slope of Two faces." ) ) { Sketchup.active_model.select_tool DSN_Click2Faces_to_fit_plane.new }
				#takdsf_cmenu.add_item( langconv( "The Average Height of Selected Edges." ) ) { calc_z_average_of_edges }
				#takdsf_cmenu.add_item( langconv( "Draw Slope Vectors on Selected Faces.") ) { draw_normal_onface }
		#	end
		#end
		#icon_changez_large.PNG
		icon_tak_dsln = File.join( File.dirname( File.expand_path(__FILE__) ), "draw_slope_normals" , "icon_changez_large.png" )
		tak_dsln_tool = UI::Command.new("Draw Slope Normals Tool") {
			Sketchup.active_model.select_tool DSN_Click_Set_vertex_zvalue.new
		}
		tak_dsln_tool.large_icon = tak_dsln_tool.small_icon = icon_tak_dsln
		tak_dsln_tool.status_bar_text = tak_dsln_tool.tooltip = langconv( "Set Z value.")
		tak_dsln_tb = UI::Toolbar.new( langconv( "Draw Slope Normals") + "TOOL" )
		tak_dsln_tb.add_item tak_dsln_tool
		tak_dsln_tb.show if tak_dsln_tb.get_last_state != 0

	end
end#class
unless( file_loaded?( "draw_slope_normals.rb" ) )
	takdsfv = Draw_slope_face_vector.new
	takdsfv.add_menus_of_this()
end
file_loaded("draw_slope_normals.rb")